const os = require('os');
const fs = require('fs');
const sh = require('shelljs');
const path = require('path');
const utils = require('../utils');

module.exports = context => {
  utils.debug('fetching a list of migratable packages...');
  const cwd = fs.mkdtempSync(path.join(os.tmpdir(), Date.now().toString()));
  const npmrc = path.join(context.cwd, '.npmrc');
  if (sh.test('-f', npmrc)) {
    sh.cp(path.join(context.cwd, '.npmrc'), cwd);
  }
  const command = 'npm install --silent --progress=false --fetch-retries=0 --cache-min=0 @wix/scopes@latest';
  const result = sh.exec(command, { cwd, silent: true });
  if (result.code === 0) {
    const names = require(path.join(cwd, 'node_modules/@wix/scopes/package-names.json'));
    const versions = require(path.join(cwd, 'node_modules/@wix/scopes/package-versions.json'));
    return Object.assign(context, { names, versions });
  }
  utils.debug('cannot fetch a list of migratable packages');
  return Promise.reject(new Error('Cannot fetch a list of migratable packages'));
};
