const checkCi = require('./check-ci');
const checkPlatform = require('./check-platform');
const checkGit = require('./check-git');
const checkYarn = require('./check-yarn');
const checkOptedOut = require('./check-opted-out');

const getNames = require('./get-names');
const getJson = require('./get-json');

const updateDependencies = require('./update-dependencies');
const removeLockFiles = require('./remove-lock-files');
const updateSources = require('./update-sources');
const getSuspiciousSources = require('./get-suspicious-sources');
const printReport = require('./print-report');

module.exports = {
  checkCi,
  checkPlatform,
  checkGit,
  checkYarn,
  checkOptedOut,

  getNames,
  getJson,

  updateDependencies,
  removeLockFiles,
  updateSources,
  getSuspiciousSources,
  printReport
};
