const utils = require('../utils');
const updatePackageJson = require('../update-package-json');

module.exports = context => {
  utils.info('Analyzing package.json for required changes...');

  return updatePackageJson(context)
    .then(payload => {
      utils.debug(`${Object.keys(payload.changes).length} changes have been found`);
      if (Object.keys(payload.changes).length > 0) {
        utils.debug('updating package.json...');
        return utils.writeJson(context.fileName, context.json).then(() => payload);
      }
      return payload;
    })
    .then(payload => Object.assign(context, {
      changes: payload.changes,
      outdated: payload.outdated
    }));
};
