const path = require('path');
const utils = require('./utils');
const tasks = require('./tasks');

const versionOfTheTool = require('../package.json').version;

module.exports = (fileName, options) => {

  const context = Object.assign({
    checkCi: false,
    checkPlatform: false,
    checkYarn: false,
    checkGit: false,
    checkVersions: false,
    updateSources: false,

    fileName,
    cwd: path.dirname(fileName)
  }, options);

  return Promise
    .resolve(context)
    .then(utils.run([
      tasks.checkCi,
      tasks.checkPlatform,
      tasks.checkYarn,
      tasks.getNames,
      tasks.checkGit,
      context => {
        console.log('update scopes version:', versionOfTheTool);
        return context;
      },
      tasks.getJson,
      tasks.checkOptedOut,
      tasks.updateDependencies,
      tasks.removeLockFiles,
      tasks.updateSources,
      tasks.getSuspiciousSources,
      tasks.printReport
    ]));
};
